import es
import playerlib
import psyco
import gamethread
import popuplib
import cfglib
import sys
import time
psyco.full()
info = es.AddonInfo()
info.name = "Last Man"
info.version = "1.0"
info.author = "sonicsight"
info.url = "http://www.sonicsightz.com/"
info.basename = "lastMan"
info.description = "Shows admins a list of the most recent people to leave the server."
config = cfglib.AddonCFG(es.getAddonPath("lastMan") + "/settings.cfg")
config.text("******************************")
config.text("  Last Man Settings")
config.text("******************************")
adminType = config.cvar("adminType",1, "Setting this to one will cause it to get the admins from the mani config file, setting it to 0 will cause it to load the admins from admins.txt")
allowBan = config.cvar("allowBan",1,"Enable/Disable allowing the banning of players via the popup")
banTime = config.cvar("banTime",0,"Time in minutes to ban players for. Setting this to 0 will result in perminant bans.")
keepTime = config.cvar("keepTime",60,"Time in seconds to keep players in the list.")
logBans = config.cvar("logBans",1,"Enable/Disbale ban logging.")
config.write()
lastMen = {}
clientsPath = str(es.ServerVar('eventscripts_gamedir')) + '/cfg/mani_admin_plugin/clients.txt'
list_admins = ['STEAM_ID_LAN']
def load():
    config.execute()
    es.set("%s_version" % info.basename,info.version)
    es.makepublic("%s_version" % info.basename)
    es.msg("#multi","#green [%s]#default %s has loaded." % (info.basename,info.name))
    es.regsaycmd("!lastman","lastMan/showPop")
    loadAdmins()
def unload():
    es.msg("#multi","#green [%s]#default %s has unloaded." % (info.basename,info.name))
    es.unregsaycmd("!lastman")
def es_map_start(ev):
    lastMen.clear()
    loadAdmins()
    config.execute()
def player_disconnect(ev):
    lastMen[ev['networkid']] = ev['name']
    gamethread.delayed(keepTime,removePlayer,ev['networkid'])
def log(message):
    pfad = str(es.getAddonPath('lastMan')) + '/log.txt'
    timestring = time.strftime("%d.%m.%Y-%H:%M:%S", time.localtime())
    logfile = open(pfad, 'a')
    msg = "%s \n" % message
    logfile.write('[%s] %s' % (timestring,msg))
    logfile.close()
def loadAdmins():
    while len(list_admins) > 0:
        list_admins.remove(list_admins[0])
    list_admins.append('STEAM_ID_LAN')
    if int(adminType) == 1:
        getAdminsMani()
    elif int(adminType) == 0:
        getAdminsFile()
def getAdminsMani():
    clientsFile = open(clientsPath, 'r')
    for line in clientsFile:
        list_line = line.split('"')
        if len(list_line) > 3:
            if list_line[3].startswith('STEAM_'):
                list_admins.append(list_line[3])
    clientsFile.flush()
    clientsFile.close()
def getAdminsFile():
    tempsteam = open(es.getAddonPath("lastMan") + '/admins.txt')
    for line in tempsteam:
        line = line.strip("\n")
        if line[0] != "/" and line[1] != "/":
            list_admins.append(line)
    tempsteam.close
def showPop():
    uId = es.getcmduserid()
    sId = es.getplayersteamid(uId)
    if sId in list_admins:
        lmPop = popuplib.easymenu("lmPop",None,showBan)
        lmPop.settitle("Last Men To Leave:")
        for guy in lastMen:
            lmPop.addoption(guy,lastMen[guy])
        lmPop.send(uId)
def showBan(uId,sId,pId):
    if int(allowBan) == 1:
        banPop = popuplib.easymenu("banPop",None,execBan)
        banPop.settitle("Ban Player? (Steam: %s"%sId)
        banPop.addoption(sId,"Yes")
        banPop.addoption(None,"No")
        banPop.send(uId)
    elif int(allowBan) == 0:
        banPop = popuplib.create("banPop")
        banPop.addline("Banning has been turned off by a server admin.")
        banPop.addline("The STEAM ID of the player you selected is: %s"%sId)
        banPop.send(uId)
def execBan(uId,sId,pId):
    if sId != None:
        if int(logBans) == 1:
            log("Player: %s was banned by Admin: %s"%(es.getplayername(es.getuserid(sId)),es.getplayername(uId)))
        es.server.cmd("banid %s %s"%(banTime,sId))
        es.server.cmd("kickid %s You have been banned by an admin."%(sId))
        if sId in lastMen:
            del lastMen[sId]
def removePlayer(name):
    if name in lastMen:
        del lastMen[name]